%assume the 64 elements located on a square spaced at 1cm and we can set the
%maximum power is from angle theta.



function [t,T,phase,wave,Fs,N] = BFtheta(Fs,N,theta,Dist,F0)
    t=[0:N-1]/Fs;
    x0=Dist*cosd(theta); % x coordinate of socurse
    y0=Dist*sind(theta); % y coordinate of sourse
%     x=[8,8,-8,-8];
%     y=[8,-8,-8,8];
    x=[8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,-[-8:8],-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,[-8:8]]; % x y coordinate of elements by the order of top right and clockwise
    y=[-[-8:8],-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,-8,[-8:8],8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8];
    dist=((x-x0).^2+(y-y0).^2).^(1/2);% distance of source to each element in cm
    T=dist./34000; %time to arrive to each element in second 
%     phase=[T(1);T(2);T(3);T(4)];
phase=[T(1);T(2);T(3);T(4);T(5);T(6);T(7);T(8);T(9);T(10);T(11);T(12);T(13);T(14);T(15);T(16);
T(17);T(18);T(19);T(20);T(21);T(22);T(23);T(24);T(25);T(26);T(27);T(28);T(29);T(30);T(31);T(32);
T(33);T(34);T(35);T(36);T(37);T(38);T(39);T(40);T(41);T(42);T(43);T(44);T(45);T(46);T(47);T(48);
T(49);T(50);T(51);T(52);T(53);T(54);T(55);T(56);T(57);T(58);T(59);T(60);T(61);T(62);T(63);T(64)];
    a=floor(phase*Fs);
    b=sin(2*F0*pi*t);
    for i=1:64
    wave(i,:)=[zeros(1,a(i)),b(1:N-a(i))];
    end
%     wave(2,:)=[zeros(1,a(2)),b(1:N-a(2))];
%     wave(3,:)=[zeros(1,a(3)),b(1:N-a(3))];
%     wave(4,:)=[zeros(1,a(4)),b(1:N-a(4))];
%    
%     phase=[T(1);T(2);T(3);T(4);T(5);T(6);T(7);T(8);T(9);T(10);T(11);T(12);T(13);T(14);T(15);T(16);
%          T(17);T(18);T(19);T(20);T(21);T(22);T(23);T(24);T(25);T(26);T(27);T(28);T(29);T(30);T(31);T(32);
%          T(33);T(34);T(35);T(36);T(37);T(38);T(39);T(40);T(41);T(42);T(43);T(44);T(45);T(46);T(47);T(48);
%          T(49);T(50);T(51);T(52);T(53);T(54);T(55);T(56);T(57);T(58);T(59);T(60);T(61);T(62);T(63);T(64)];
%      time=[t+T(1);t+T(2);t+T(3);t+T(4);t+T(5);t+T(6);t+T(7);t+T(8);t+T(9);t+T(10);t+T(11);t+T(12);t+T(13);t+T(14);t+T(15);t+T(16);
%          t+T(17);t+T(18);t+T(19);t+T(20);t+T(21);t+T(22);t+T(23);t+T(24);t+T(25);t+T(26);t+T(27);t+T(28);t+T(29);t+T(30);t+T(31);t+T(32);
%          t+T(33);t+T(34);t+T(35);t+T(36);t+T(37);t+T(38);t+T(39);t+T(40);t+T(41);t+T(42);t+T(43);t+T(44);t+T(45);t+T(46);t+T(47);t+T(48);
%          t+T(49);t+T(50);t+T(51);t+T(52);t+T(53);t+T(54);t+T(55);t+T(56);t+T(57);t+T(58);t+T(59);t+T(60);t+T(61);t+T(62);t+T(63);t+T(64)];
%     wave=sin(100*pi*(time));
    
end